#ifndef __MWAY_H_
#define __MWAY_H_


#include <vector>
#include <iostream>
#include <fstream>
#include <time.h>
using namespace std;

void filer();

struct Node{
	ifstream file;
	int numread;

	Node(const char * name) :file(name){numread = 0;}
	~Node(){file.close();}
};

struct AnotherNode{
	ofstream file;
	int numwrite;

	AnotherNode(const char * name) :file(name){numwrite = 0;}
	~AnotherNode(){file.close();}
};

class MWEMS{
public:
	MWEMS(vector<const char *> & files);
private:
	vector<Node *> source_files;//hold source files
	//hold the files that cannot be used in that step
	vector<Node *> patient_files;
	vector<AnotherNode *> destination_files;//hold destintion files
	vector<int> current_data;//the latest data of each file
	vector<const char *> pathofinfiles;//path of input files
	vector<const char *> pathoftmpfiles;//path of temp files
	int numberofiles;//number of files that isn't empty yet
	//if 0:input ---> temp
	//if 1:temp  ---> input
	int phase;

	int findmin();
	void readmdata(int m);
	void deal_with(int where,int frequency,int limit,int pay);
	void eliminate(int where);
	void loader();
	void decnumberofiles();
	void statix();

	void sorter(int numberofmyfiles);
};







#endif